package jp.osoite.tomu.core.main;

import jp.osoite.tomu.sensor.tscan.socks.TScanReceiverRunnable;
import jp.osoite.tomu.net.mail.MailScheduleManager;
import jp.osoite.tomu.net.xmpp.XMPPDeamonRunnable;
import jp.osoite.tomu.xml.jaxb.object.TomuMessage;
import jp.osoite.tomu.xml.jaxb.util.JAXBConverter;
import jp.osoite.tomu.xml.jaxb.util.builder.DummyTomuMessageFactory;
import jp.osoite.tomu.xml.jaxb.util.builder.DummyTomuMessageFactory.DummyMessageType;
import jp.osoite.tomu.xmpp.core.XMPPManager;
import jp.osoite.tomu.xmpp.core.XMPPManagersFactory;

/**
 *
 * @author tailor
 */
public class Main2 {

    private static final boolean BOOL_XMPP_RV = true;
    private static final boolean BOOL_TSCAN_RV = false;
    private static final boolean BOOL_FILE_RV = false;
    private static final boolean BOOL_HUMANSS_INIT_TEST = false;
    private static final boolean BOOL_MAIL_SD = false;

    public static void main(String[] args) throws Exception {

        System.out.println("tomu on Main2");

        if (BOOL_XMPP_RV) {
            IConnection xmppConnector = NetwokConnectorFactory.getConnector(NetwokConnectorFactory.TYPE_XMPP);
        }

        /*
        ITreeTest it=new ITreeTest();
        it.start();
        it.initTreeDemo();
         */

        if (BOOL_TSCAN_RV) {
            new Thread(new TScanReceiverRunnable()).start();
        }

        if (BOOL_FILE_RV) {
            IConnection fileconnector = NetwokConnectorFactory.getConnector(NetwokConnectorFactory.TYPE_FILE);
            MainController.getInstance().append("File Loader is started...\n");
        }

        if (BOOL_HUMANSS_INIT_TEST) {
            long sensorID = System.currentTimeMillis();
            int i = 2;
            TomuMessage tomumsgobj = DummyTomuMessageFactory.getSourceUpload(DummyMessageType.PEDESTRIAN);
            XMPPManager manager = XMPPManagersFactory.getInstance().getXMPPManager(XMPPDeamonRunnable.DEF_TOMU_NUM);
            manager.getMessageReceiver().receive(JAXBConverter.convertToXml(tomumsgobj));

            while (i-- > 0) {

                if (i == 10)//||i==15)
                {
                    Thread.sleep(4 * 60 * 1000);
                }
                Thread.sleep(1 * 1000);
                tomumsgobj = DummyTomuMessageFactory.getSourceUpload(DummyMessageType.PEDESTRIAN);
                manager.getMessageReceiver().receive(JAXBConverter.convertToXml(tomumsgobj));
            }
        }

        if (BOOL_MAIL_SD) {

            System.out.println("mail pre send");
            //JavaMailSend.getInstance().send_errmsg(3);
            System.out.println("mail after send");

            MailScheduleManager.doJob();

            //JavaMailReceive.getInstance().receivemail();
        }

        //MainController.getInstance().addSensorVals(sval);

        //    /*
        //while(i>0){
        //
        //    i--;
        //
        //              TomuMessage tomumsgobj = TomuDummyMessageFactory.getSourceUploadStaticHumanSensor("dest@hoge.jp", "src@hoge.jp");
        //            PedestrianFlowValue psensorvalue =(PedestrianFlowValue)ISensorValueConverter.convertToISensorValue(tomumsgobj);
        //          MainController.getInstance().addPedestrianSensorValue(psensorvalue);
        //        Thread.sleep(1000);
        //  }
        //     * */
//        }


        //IConnection xmppConnector = NetwokConnectorFactory.getConnector(NetwokConnectorFactory.TYPE_XMPP_SENSORSOURCE);

        if (false) {
            IConnection fileConnector = NetwokConnectorFactory.getConnector(NetwokConnectorFactory.TYPE_FILE);
            MainController.getInstance().append("File Loader is started...\n");
            ///////MainController.getInstance().addXXXConnectionsColoseListener(fileConnector);
        }

    }
}
