/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jp.osoite.tomu.xmpp.core;

import jp.osoite.tomu.xml.jaxb.object.TomuMessage;
import jp.osoite.tomu.xml.jaxb.wrapper.UploadKito2Wrapper;
import java.sql.DriverManager;
import java.sql.ResultSet;
import jp.osoite.tomu.usml.Config;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import jp.osoite.tomu.util.TimeConverter;
import jp.osoite.tomu.xml.jaxb.util.TomuMessageType;
import jp.osoite.tomu.xml.jaxb.util.builder.JAXBConstructor;

/**
 *
 * @author tomu
 */
public class KodamaOrientationTest {

    String DATABASE_URL = "";
    String DATABASE_NAME = "";
    String DATABASE_USER = "";
    String DATABASE_PASSWORD = "";
    String JDBC_DRIVER = "";
    String SPOT_DATA_TABLE_NAME = "";
    String PEDESTRIAN_DATA_TABLE_NAME = "data_ped";
    private Statement statement = null;
    private java.sql.Connection dbCon = null;
    private String insertStmtStr;
    List<UploadKito2Wrapper> kito2ResultList = new ArrayList<UploadKito2Wrapper>();
    private final static int NORTH = 0,  NORTHEAST = 1,  EAST = 2,  SOUTHEAST = 3,  SOUTH = 4,  SOUTHWEST = 5,  WEST = 6,  NORTHWEST = 7;

    public void doTest() {
        System.out.println("OrientatoinTest");

        DATABASE_URL = Config.getInstance().getDATABASE_URL();
        DATABASE_NAME = Config.getInstance().getDATABASE_NAME();
        DATABASE_USER = Config.getInstance().getDATABASE_USER();
        DATABASE_PASSWORD = Config.getInstance().getDATABASE_PASSWORD();
        JDBC_DRIVER = Config.getInstance().getJDBC_DRIVER();
        SPOT_DATA_TABLE_NAME = Config.getInstance().getDATA_TABLE_NAME();
        System.out.println("Database demo application starting ... ");
        try {
            // Register the JDBC driver for mysql
            // This is typically found in a JAR file
            // named something like
            // mysql-connector-java-<version>-bin.jar
            // which should be in the classpath
            // See user.classpath in build.properties
            // for this Sun SPOT host application
            Class.forName(JDBC_DRIVER);
            // Define URL of database server for
            String url = DATABASE_URL + DATABASE_NAME;
            // Get a connection to the database for given user/password
            dbCon = DriverManager.getConnection(url, DATABASE_USER, DATABASE_PASSWORD);
            // Display URL and connection information
            System.out.println("URL: " + url);
            System.out.println("Connection: " + dbCon);
            System.out.println(">DB");


            try {
                // Get a Statement object
                statement = dbCon.createStatement();
            } catch (Exception e) {
                System.err.println("dbSetUp stmt: caught " + e.getMessage());
                throw e;
            }

            ResultSet rs = statement.executeQuery("select * from kito2");

            TomuMessage tomumsgobj;
            UploadKito2Wrapper ukw;
            while (rs.next()) {


                try {
                    JAXBConstructor constructor = new JAXBConstructor(TomuMessageType.SOURCE_UPLOAD);
                    constructor.setHeader("dest@hoge.com", "src@hoge.com", System.currentTimeMillis());
                    constructor.setSequence(System.currentTimeMillis());
                    constructor.addKitokitoData(rs.getLong("sensorid"), rs.getInt("compass"), JAXBConstructor.getLocation(rs.getDouble("longitude"), rs.getDouble("latitude"), 0), rs.getInt("dpi"), rs.getString("url"), rs.getString("thumbnail_url"), TimeConverter.convertToLong(rs.getString("timestamp")));
                    tomumsgobj = constructor.build();
                    ukw = new UploadKito2Wrapper(tomumsgobj);
                    kito2ResultList.add(ukw);
                    
                    
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }

            Kito2Comparator kito2Comparator = new Kito2Comparator(35, 139);
            Collections.sort(kito2ResultList, kito2Comparator);

            SfeerImages sfeerImages = new SfeerImages();
            for (UploadKito2Wrapper value : kito2ResultList) {
                int orientation = getKito2Orientation(35, 139, value.getLatitude(), value.getLongitude());
                if (!sfeerImages.isImage[orientation]) {
                    sfeerImages.data[orientation] = value;
                    sfeerImages.isImage[orientation] = true;
                    
                    System.out.println("orientation: " + orientation);
                    System.out.println("thumbnail_url: " + value.getThumbnailUrl());
                    System.out.println("latitude:" + Double.toString(value.getLatitude()));
                    System.out.println("longitude:" + Double.toString(value.getLongitude()));
                    
                }
            }

        } catch (Exception e) {
            System.err.println("setUp caught " + e);
            System.err.println("Make sure that mySQL is installed properly \n" + "and has a Test database accessible via the \n" + "default administrator settings on localhost:3306\n");
        //throw e;
        }
    }

    private int getKito2Orientation(double mLat, double mLon, double tLat, double tLon) {
        mLat = mLat / 180 * Math.PI;
        mLon = mLon / 180 * Math.PI;
        tLat = tLat / 180 * Math.PI;
        tLon = tLon / 180 * Math.PI;
        double orientation=Math.atan2(Math.cos(tLat)*Math.sin(tLon-mLon), Math.cos(mLat)*Math.sin(tLat)-Math.sin(mLat)*Math.cos(tLat)*Math.cos(tLon-mLon));
        if(orientation<0){
            orientation+=(Math.PI*2);
        }
        //System.out.println("orientation: " + (orientation/Math.PI*180));
        return (int)Math.round(orientation / (Math.PI/4))%8;
    }

    public class SfeerImages {

        public UploadKito2Wrapper[] data;
        public boolean[] isImage;

        public SfeerImages() {
            data = new UploadKito2Wrapper[8];
            isImage = new boolean[8];
            for (int i = 0; i < 8; i++) {
                isImage[i] = false;
            }
        }
    }
    
    /*
    public class Kito2Comparator implements Comparator {

        double mLat, mLon;

        public Kito2Comparator(double latitude, double longitude) {
            mLat = latitude;
            mLon = longitude;
        }

        public int compare(Object ukw1, Object ukw2) {
            return (int) Math.round(getDistance(mLat, mLon, ((UploadKito2Wrapper) ukw1).getLatitude(), ((UploadKito2Wrapper) ukw1).getLongitude()) - getDistance(mLat, mLon, ((UploadKito2Wrapper) ukw2).getLatitude(), ((UploadKito2Wrapper) ukw2).getLongitude()));
        }

        private double getDistance(double lat1, double lon1, double lat2, double lon2) {
            return Math.sqrt(Math.pow((lon1 - lon2) * Math.cos((lat1 + lat2) / 2 / 180 * Math.PI), 2) + Math.pow(lat1 - lat2, 2));
        //http://oshiete.goo.ne.jp/qa/249931.html
        }
    }*/
}
